using System;

using EchoServerCLRManagedHostInterfaces;

namespace EchoServerCLR
{
   class ManagedHost : AppDomainManager, IManagedHost
   {
      public override void InitializeNewDomain(AppDomainSetup appDomainInfo)
      {
         // let the unmanaged host know about us
         InitializationFlags = AppDomainManagerInitializationOptions.RegisterWithHost;
      }

      int IManagedHost.CreateAppDomain(string name)
      {
         // we could also create a managed 'user data' holder object that we can return via com
         // and store in the unmanaged socket's user data...

         return AppDomain.CreateDomain(name).Id;
      }

      void IManagedHost.OnConnectionEstablished(
         ISocket socket)
      {
         socket.WriteString("Welcome to CLR echo server\r\n");

         socket.Read();
      }
 
      void IManagedHost.OnReadCompleted(
         byte[] data,
         ISocket socket)
      {
          socket.Write(data);

          socket.Read();
       }

      void IManagedHost.OnConnectionClientClose(
         ISocket socket)
      {

      }
   }
}
