@Echo off

REM Most arguments passed to us via the environment as they contain spaces...

if not defined SERVER goto NotSet
if not defined BASE_ARGS goto NotSet
if not defined NUM_CONNECTIONS set NUM_CONNECTIONS=50
if not defined NUM_MESSAGES set NUM_MESSAGES=1000

goto RunTests

:NotSet
Echo One or more of the following variables is not set:
Echo -
Echo SERVER=%SERVER%
Echo BASE_ARGS=%BASE_ARGS%
Echo -
Echo Please ensure they are all set in the environment before calling.
Exit /b 1

:RunTests

setlocal

set TEST_CLIENT_BASE_ARGS=-server localhost -connections %NUM_CONNECTIONS% -connectionBatchSize 100 -connectionBatchDelay 100 -messages %NUM_MESSAGES% -messageSize 1000 -messageRate 0 -sendAfterRecv -skipSignOnBytes 28 -readTimeout 10000 -messageFlowTimeout 60000

set TEST_NAME=%BASE_TEST_NAME% EchoServerTest.exe on port 5050
set SERVER_ARGS=%BASE_ARGS%
set TEST_CLIENT="..\..\Test\EchoServerTest.exe"
set TEST_CLIENT_ARGS=-port 5050 %TEST_CLIENT_BASE_ARGS%

REM most arguments passed to RunTest.bat via the environment as they contain spaces...

call ..\..\Test\RunTest.bat
if ERRORLEVEL 1 Exit /b %ERRORLEVEL%

set TEST_NAME=%BASE_TEST_NAME% EchoServerTest.exe on port 5051
set TEST_CLIENT_ARGS=-port 5051 %TEST_CLIENT_BASE_ARGS%

call ..\..\Test\RunTest.bat
if ERRORLEVEL 1 Exit /b %ERRORLEVEL%

