///////////////////////////////////////////////////////////////////////////////
// File: IOPool.cpp
///////////////////////////////////////////////////////////////////////////////
//
// Copyright 2011 JetByte Limited.
//
// This software is provided "as is" without a warranty of any kind. All
// express or implied conditions, representations and warranties, including
// any implied warranty of merchantability, fitness for a particular purpose
// or non-infringement, are hereby excluded. JetByte Limited and its licensors
// shall not be liable for any damages suffered by licensee as a result of
// using the software. In no event will JetByte Limited be liable for any
// lost revenue, profit or data, or for direct, indirect, special,
// consequential, incidental or punitive damages, however caused and regardless
// of the theory of liability, arising out of the use of or inability to use
// software, even if JetByte Limited has been advised of the possibility of
// such damages.
//
///////////////////////////////////////////////////////////////////////////////

#include "JetByteTools/Admin/Admin.h"

#include "IOPool.h"

#pragma hdrstop

#include "ObjBase.h"

///////////////////////////////////////////////////////////////////////////////
// Using directives
///////////////////////////////////////////////////////////////////////////////

using JetByteTools::IO::IMonitorIOPool;

///////////////////////////////////////////////////////////////////////////////
// CIOPool
///////////////////////////////////////////////////////////////////////////////

CIOPool::CIOPool(
   const ThreadCount numThreads)
   :  JetByteTools::IO::CIOPool(numThreads)
{

}

CIOPool::CIOPool(
   IMonitorIOPool &monitor,
   const ThreadCount numThreads)
   :  JetByteTools::IO::CIOPool(monitor, numThreads)
{

}

CIOPool::~CIOPool()
{

}

bool CIOPool::InitialiseWorkerThread()
{
   return S_OK == ::CoInitializeEx(0, COINIT_MULTITHREADED);
}

void CIOPool::ShutdownWorkerThread()
{
   ::CoUninitialize();
}

///////////////////////////////////////////////////////////////////////////////
// End of file: IOPool.cpp
///////////////////////////////////////////////////////////////////////////////
