#pragma once
#ifndef ECHO_SERVER_IO_POOL_INCLUDED__
#define ECHO_SERVER_IO_POOL_INCLUDED__
///////////////////////////////////////////////////////////////////////////////
// File: IOPool.h
///////////////////////////////////////////////////////////////////////////////
//
// Copyright 2011 JetByte Limited.
//
// This software is provided "as is" without a warranty of any kind. All
// express or implied conditions, representations and warranties, including
// any implied warranty of merchantability, fitness for a particular purpose
// or non-infringement, are hereby excluded. JetByte Limited and its licensors
// shall not be liable for any damages suffered by licensee as a result of
// using the software. In no event will JetByte Limited be liable for any
// lost revenue, profit or data, or for direct, indirect, special,
// consequential, incidental or punitive damages, however caused and regardless
// of the theory of liability, arising out of the use of or inability to use
// software, even if JetByte Limited has been advised of the possibility of
// such damages.
//
///////////////////////////////////////////////////////////////////////////////

#include "JetByteTools/IOTools/IOPool.h"

///////////////////////////////////////////////////////////////////////////////
// CIOPool
///////////////////////////////////////////////////////////////////////////////

class CIOPool : public JetByteTools::IO::CIOPool
{
   public :

      explicit CIOPool(
         const ThreadCount numThreads = 0);

      explicit CIOPool(
         JetByteTools::IO::IMonitorIOPool &monitor,
         const ThreadCount numThreads = 0);

      CIOPool(
         const CIOPool &rhs) = delete;

      ~CIOPool() override;

      CIOPool &operator=(
         const CIOPool &rhs) = delete;

   private :

      // Implement IManageWorkerThreads

      bool InitialiseWorkerThread() override;

      void ShutdownWorkerThread() override;
};

#endif // ECHO_SERVER_IO_POOL_INCLUDED__

///////////////////////////////////////////////////////////////////////////////
// End of file: IOPool.h
///////////////////////////////////////////////////////////////////////////////
