using System;

using System.Threading;

using EchoServerCLRManagedHostInterfaces;

namespace EchoServerCLR
{
   class ManagedHost : AppDomainManager, IManagedHost
   {
      private string name;

      public override void InitializeNewDomain(AppDomainSetup appDomainInfo)
      {
         // let the unmanaged host know about us
         InitializationFlags = AppDomainManagerInitializationOptions.RegisterWithHost;
      }

      public override AppDomain CreateDomain(string friendlyName, System.Security.Policy.Evidence securityInfo, AppDomainSetup appDomainInfo)
      {
         name = friendlyName;

         AppDomain app = base.CreateDomain(friendlyName, securityInfo, appDomainInfo);

         return app;
      }

      int IManagedHost.CreateAppDomain(string name)
      {
         // we could also create a managed 'user data' holder object that we can return via com
         // and store in the unmanaged socket's user data...

         AppDomain app = AppDomain.CreateDomain(name);

         app.UnhandledException += UnhandledException;

         return app.Id;
      }

      private static void UnhandledException(object sender, UnhandledExceptionEventArgs e)
      {

      }

      void IManagedHost.OnConnectionEstablished(
         ISocket socket)
      {
         socket.WriteString("Welcome to CLR echo server\r\n");

         socket.Read();
      }
 
      void IManagedHost.OnReadCompleted(
         byte[] data,
         ISocket socket)
      {
          socket.Write(data);

          socket.Read();
       }

      void IManagedHost.OnConnectionClientClose(
         ISocket socket)
      {

      }
   }
}
