using System;

using System.Threading;

using EchoServerCLRManagedHostInterfaces;

namespace EchoServerCLR
{
   class ManagedApplication : IManagedApplicationControl, IManagedApplication
   {
      private string name;

      private IHostLog log;

      private void LogMessage(string message)
      {
         log.LogMessage(AppDomain.CurrentDomain.Id + ": " + name + ": " + message);
      }

      IManagedApplication IManagedApplicationControl.OnApplicationStart(
         string applicationName, 
         IHostLog log)
      {
         this.name = applicationName;

         this.log = log;

         LogMessage("OnApplicationStart");

         return this;
      }

      void IManagedApplicationControl.OnApplicationStopRequested()
      {
         LogMessage("OnApplicationStopRequested");
      }

      void IManagedApplicationControl.OnApplicationStop()
      {
         LogMessage("OnApplicationStop");
      }

      void IManagedApplication.OnConnectionEstablished(
         ISocket socket)
      {
         socket.WriteString("Welcome to CLR echo server: " + name + "\r\n");

         socket.Read();
      }

      void IManagedApplication.OnReadCompleted(
         byte[] data,
         ISocket socket)
      {
          socket.Write(data);

          socket.Read();
       }

      void IManagedApplication.OnConnectionClientClose(
         ISocket socket)
      {
         LogMessage("OnConnectionClientClose");
      }
   }
}
