#pragma once
#ifndef ECHO_SERVER_PER_CONNECTION_USER_DATA_INCLUDED__
#define ECHO_SERVER_PER_CONNECTION_USER_DATA_INCLUDED__
///////////////////////////////////////////////////////////////////////////////
// File: PerConnectionData.h
///////////////////////////////////////////////////////////////////////////////
//
// Copyright 2010 JetByte Limited.
//
// This software is provided "as is" without a warranty of any kind. All
// express or implied conditions, representations and warranties, including
// any implied warranty of merchantability, fitness for a particular purpose
// or non-infringement, are hereby excluded. JetByte Limited and its licensors
// shall not be liable for any damages suffered by licensee as a result of
// using the software. In no event will JetByte Limited be liable for any
// lost revenue, profit or data, or for direct, indirect, special,
// consequential, incidental or punitive damages, however caused and regardless
// of the theory of liability, arising out of the use of or inability to use
// software, even if JetByte Limited has been advised of the possibility of
// such damages.
//
///////////////////////////////////////////////////////////////////////////////

#include <objidl.h>

///////////////////////////////////////////////////////////////////////////////
// Classes defined in other files...
///////////////////////////////////////////////////////////////////////////////

namespace JetByteTools
{
   namespace Core
   {
      class IReentrantLockableObject;
   }

   namespace IO
   {
      class IBuffer;
   }

   namespace Socket
   {
      class IStreamSocket;
   }
}

class CApplication;

class CSocket;

///////////////////////////////////////////////////////////////////////////////
// CPerConnectionData
///////////////////////////////////////////////////////////////////////////////

class CPerConnectionData
{
   public :

      CPerConnectionData(
         CApplication &application,
         JetByteTools::Socket::IStreamSocket &socket);

      CPerConnectionData(
         const CPerConnectionData &rhs) = delete;

      ~CPerConnectionData();

      CPerConnectionData &operator=(
         const CPerConnectionData &rhs) = delete;

      void OnConnectionEstablished();

      void OnReadCompleted(
         const JetByteTools::IO::IBuffer &buffer);

      void OnConnectionClientClose();

   private :

      JetByteTools::Core::IReentrantLockableObject &m_lock;

      CApplication &m_application;

      CSocket *m_pSocket;

      SAFEARRAY *m_pArray;
};

#endif // ECHO_SERVER_PER_CONNECTION_USER_DATA_INCLUDED__

///////////////////////////////////////////////////////////////////////////////
// End of file: PerConnectionData.h
///////////////////////////////////////////////////////////////////////////////
