#pragma once
#ifndef ECHO_SERVER_SOCKET_SERVER_SOCKET_INCLUDED__
#define ECHO_SERVER_SOCKET_SERVER_SOCKET_INCLUDED__
///////////////////////////////////////////////////////////////////////////////
// File: Socket.h
///////////////////////////////////////////////////////////////////////////////
//
// Copyright 2007 JetByte Limited.
//
// This software is provided "as is" without a warranty of any kind. All
// express or implied conditions, representations and warranties, including
// any implied warranty of merchantability, fitness for a particular purpose
// or non-infringement, are hereby excluded. JetByte Limited and its licensors
// shall not be liable for any damages suffered by licensee as a result of
// using the software. In no event will JetByte Limited be liable for any
// lost revenue, profit or data, or for direct, indirect, special,
// consequential, incidental or punitive damages, however caused and regardless
// of the theory of liability, arising out of the use of or inability to use
// software, even if JetByte Limited has been advised of the possibility of
// such damages.
//
///////////////////////////////////////////////////////////////////////////////

#include <objidl.h>

#include "ManagedHostInterface/IManagedHost.h"

///////////////////////////////////////////////////////////////////////////////
// Classes defined in other files...
///////////////////////////////////////////////////////////////////////////////

namespace JetByteTools
{
   namespace Socket
   {
      class IStreamSocket;
   }
}

///////////////////////////////////////////////////////////////////////////////
// CSocket
///////////////////////////////////////////////////////////////////////////////

class CSocket : public ISocket
{
   public :

      explicit CSocket(
         JetByteTools::Socket::IStreamSocket &socket);

      CSocket(
         const CSocket &rhs) = delete;

      CSocket &operator=(
         const CSocket &rhs) = delete;

      JetByteTools::Socket::IStreamSocket &GetSocket() const;

      void Disconnect();

   private :

      ~CSocket();

      // Implement IUnknown

      ULONG STDMETHODCALLTYPE AddRef();

      ULONG STDMETHODCALLTYPE Release();

      HRESULT STDMETHODCALLTYPE QueryInterface(
         REFIID riid,
         PVOID *ppvObj);

      // Implement ISocket

      HRESULT STDMETHODCALLTYPE WriteString(
         BSTR data);

      HRESULT STDMETHODCALLTYPE Write(
         SAFEARRAY *data);

      HRESULT STDMETHODCALLTYPE Read();

      JetByteTools::Socket::IStreamSocket *m_pSocket;

      LONG m_ref;
};

#endif // ECHO_SERVER_SOCKET_SERVER_SOCKET_INCLUDED__

///////////////////////////////////////////////////////////////////////////////
// End of file: Socket.h
///////////////////////////////////////////////////////////////////////////////
