@Echo off

REM Most arguments passed to us via the environment as they contain spaces...

if not defined SERVER goto NotSet
if not defined BASE_ARGS goto NotSet

goto DisplayDebug

:NotSet
Echo One or more of the following variables is not set:
Echo -
Echo SERVER=%SERVER%
Echo BASE_ARGS=%BASE_ARGS%
Echo -
Echo Please ensure they are all set in the environment before calling.
Exit /b 1

:DisplayDebug

if not defined JETBYTE_DEBUG_BUILD_SCRIPTS goto NoDebug

Echo Script debug information - RunTests.bat
Echo - 
Echo Required: SERVER=%SERVER%
Echo Required: BASE_ARGS=%BASE_ARGS%
Echo -

:NoDebug

:RunTests

setlocal

set TEST_NAME=EchoServerTest.exe - No zero read - 5051
set SERVER_ARGS=%BASE_ARGS%
set TEST_CLIENT="..\..\Test\EchoServerTest.exe"
set TEST_CLIENT_ARGS=-server localhost -port 5051 -connections 50 -connectionBatchSize 100 -connectionBatchDelay 100 -messages 1000 -messageSize 1000 -messageRate 0 -sendAfterRecv -skipSignOnBytes 43 -readTimeout 10000 -messageFlowTimeout 60000

REM most arguments passed to RunTest.bat via the environment as they contain spaces...

call ..\..\Test\RunTest.bat
if ERRORLEVEL 1 Exit /b %ERRORLEVEL%

set TEST_NAME=SocketServerTest.exe - No zero read - 5051
set SERVER_ARGS=%BASE_ARGS%
set TEST_CLIENT="..\..\Test\SocketServerTest.exe"
set TEST_CLIENT_ARGS=EchoServerTest.xml

call ..\..\Test\RunTest.bat
if ERRORLEVEL 1 Exit /b %ERRORLEVEL%

:Done
