@Echo off

cd ..\Test

setlocal

REM Uncomment to enable some debug info on what variables are set and why things
REM are happening (or not happening)
REM set JETBYTE_DEBUG_BUILD_SCRIPTS=YES

set OUT_DIR=%1%

if defined OUT_DIR goto RunTests

Echo Usage: TestServer.bat $(OutDir) [x86]
Echo OUT_DIR=%OUT_DIR%
Exit /b 1

:RunTests

set OUT_DIR=..\%OUT_DIR%

REM comment this out to NOT run the memory usage test
set MEMORY_LIMIT=200000000

REM uncomment this out to run the lock inversion detector
set SERVER_USE_LID=TRUE
REM uncomment this out to run the full deadlock detector
REM set SERVER_USE_LIA=TRUE

REM uncomment this to run the lock inversion detector on the client side of the test
set CLIENT_USE_LID=TRUE
REM uncomment this to run the full deadlock detector on the client side of the test
REM set CLIENT_USE_LIA=TRUE

set SERVER=EchoServerCLR4.exe
set BASE_ARGS=-port 5050 -listenBacklog 100
set CHANGE_TO_WORKING_DIR=%OUT_DIR%
set WORKING_DIR_IS_SERVER_DIR=TRUE

REM This is just requried for mixed mode debugging in VS2010

copy ..\EchoServerCLR4.exe.config %OUT_DIR%

REM Build the application directory structure

Echo Building application directory structure

pushd %OUT_DIR%

rmdir Apps /s/q
rmdir Shared /s/q

mkdir Shared
mkdir Apps
mkdir Apps\Application1
mkdir Apps\Application2
mkdir Apps\Application3
mkdir Apps\Application4

copy ManagedHost.dll Shared
copy EchoServerCLRManagedHostInterfaces.dll Shared

copy ManagedApplication.dll Apps\Application1
copy ManagedApplication.dll Apps\Application2
copy ManagedApplication.dll Apps\Application3
copy ManagedApplication.dll Apps\Application4

popd

Echo Finished building application directory structure

REM arguments passed to RunTests.bat via the environment as they contain spaces...

set TEST_SCRIPT=..\Test\RunTests.bat

call ..\..\Test\RunInstrumentedTests.bat
if ERRORLEVEL 1 Exit /b %ERRORLEVEL%

Echo Done
