#pragma once
#ifndef ECHO_SERVER_UNMANAGED_HOST_INCLUDED__
#define ECHO_SERVER_UNMANAGED_HOST_INCLUDED__
///////////////////////////////////////////////////////////////////////////////
// File: UnmanagedHost.h
///////////////////////////////////////////////////////////////////////////////
//
// Copyright 2010 JetByte Limited.
//
// This software is provided "as is" without a warranty of any kind. All
// express or implied conditions, representations and warranties, including
// any implied warranty of merchantability, fitness for a particular purpose
// or non-infringement, are hereby excluded. JetByte Limited and its licensors
// shall not be liable for any damages suffered by licensee as a result of
// using the software. In no event will JetByte Limited be liable for any
// lost revenue, profit or data, or for direct, indirect, special,
// consequential, incidental or punitive damages, however caused and regardless
// of the theory of liability, arising out of the use of or inability to use
// software, even if JetByte Limited has been advised of the possibility of
// such damages.
//
///////////////////////////////////////////////////////////////////////////////

#include <objidl.h>

#include "ManagedHostInterface/IManagedHost.h"

///////////////////////////////////////////////////////////////////////////////
// CUnmanagedHost
///////////////////////////////////////////////////////////////////////////////

class CUnmanagedHost : public IUnmanagedHost
{
   public :

      CUnmanagedHost();

      CUnmanagedHost(
         const CUnmanagedHost &rhs) = delete;

      CUnmanagedHost &operator=(
         const CUnmanagedHost &rhs) = delete;

   private :

      ~CUnmanagedHost();

      // Implement IUnknown

      ULONG STDMETHODCALLTYPE AddRef();

      ULONG STDMETHODCALLTYPE Release();

      HRESULT STDMETHODCALLTYPE QueryInterface(
         REFIID riid,
         PVOID *ppvObj);

      // Implement IUnmanagedHost

      HRESULT STDMETHODCALLTYPE ShutdownHost();

      // Implement IHostLog

      HRESULT STDMETHODCALLTYPE LogMessage(
         BSTR message);

      LONG m_ref;
};

#endif // ECHO_SERVER_UNMANAGED_HOST_INCLUDED__

///////////////////////////////////////////////////////////////////////////////
// End of file: UnmanagedHost.h
///////////////////////////////////////////////////////////////////////////////
