@Echo off

REM Most arguments passed to us via the environment as they contain spaces...

if not defined SERVER goto NotSet
if not defined BASE_ARGS goto NotSet
if not defined NUM_CONNECTIONS set NUM_CONNECTIONS=500
if not defined NUM_MESSAGES set NUM_MESSAGES=1000

goto DisplayDebug

:NotSet
Echo One or more of the following variables is not set:
Echo -
Echo SERVER=%SERVER%
Echo BASE_ARGS=%BASE_ARGS%
Echo -
Echo Please ensure they are all set in the environment before calling.
Exit /b 1

:DisplayDebug

if not defined JETBYTE_DEBUG_BUILD_SCRIPTS goto NoDebug

Echo Script debug information - RunTests.bat
Echo - 
Echo Required: SERVER=%SERVER%
Echo Required: BASE_ARGS=%BASE_ARGS%
Echo Optional: SUPPORTS_ZERO_BYTE_READ=%SUPPORTS_ZERO_BYTE_READ%
Echo Optional: SIGN_ON_BYTES=%SIGN_ON_BYTES%
Echo Optional: NUM_CONNECTIONS=%NUM_CONNECTIONS%
Echo Optional: NUM_MESSAGES=%NUM_MESSAGES%
Echo Optional: READ_TIMEOUT=%READ_TIMEOUT%
Echo -

:NoDebug

:RunTests

setlocal

if not defined READ_TIMEOUT set READ_TIMEOUT=100

if not defined NO_SKIP_SIGN_ON_BYTES goto SkipSignOnBytes

goto NoSkipSignOnBytes

:SkipSignOnBytes

if not defined SIGN_ON_BYTES set SIGN_ON_BYTES=24

set SKIP_SIGN_ON_BYTES_ARG=-skipSignOnBytes %SIGN_ON_BYTES%

:NoSkipSignOnBytes

if not defined TEST_CLIENT_EXE set TEST_CLIENT_EXE=EchoServerTest.exe
if not defined TEST_CLIENT set TEST_CLIENT="..\..\Test\%TEST_CLIENT_EXE%"
if not defined TEST_CLIENT_ARGS set TEST_CLIENT_ARGS=-server localhost -port 5050 -connections %NUM_CONNECTIONS% -connectionBatchSize 100 -connectionBatchDelay 100 -messages %NUM_MESSAGES% -messageSize 1000 -messageRate 0 -sendAfterRecv %SKIP_SIGN_ON_BYTES_ARG% -readTimeout %READ_TIMEOUT% 

set TEST_NAME=%BASE_TEST_NAME% EchoServerTest.exe - No zero read
set SERVER_ARGS=%BASE_ARGS%

REM most arguments passed to RunTest.bat via the environment as they contain spaces...

call ..\..\Test\RunTest.bat
if ERRORLEVEL 1 Exit /b %ERRORLEVEL%

REM set TEST_CLIENT_ARGS=-server localhost -port 5050 -connections %NUM_CONNECTIONS% -connectionBatchSize 100 -connectionBatchDelay 100 -messages %NUM_MESSAGES% -messageSize 1000 -messageRate 0 -sendAfterRecv -skipSignOnBytes %SIGN_ON_BYTES% -readTimeout 10000 -messageFlowTimeout 60000 -fragments -multipleMessages

REM set TEST_NAME=%BASE_TEST_NAME% EchoServerTest.exe - No zero read, fragments, multi
REM call ..\..\Test\RunTest.bat
REM if ERRORLEVEL 1 Exit /b %ERRORLEVEL%

if not defined SUPPORTS_ZERO_BYTE_READ goto Done

REM set TEST_CLIENT_ARGS=-server localhost -port 5050 -connections %NUM_CONNECTIONS% -connectionBatchSize 100 -connectionBatchDelay 100 -messages %NUM_MESSAGES% -messageSize 1000 -messageRate 0 -sendAfterRecv -skipSignOnBytes %SIGN_ON_BYTES% -readTimeout 10000 -messageFlowTimeout 60000

set TEST_NAME=%BASE_TEST_NAME% EchoServerTest.exe - Sync zero read
set SERVER_ARGS=%BASE_ARGS% -syncZero

call ..\..\Test\RunTest.bat
if ERRORLEVEL 1 Exit /b %ERRORLEVEL%

set TEST_NAME=%BASE_TEST_NAME% EchoServerTest.exe - Async zero read
set SERVER_ARGS=%BASE_ARGS% -asyncZero

call ..\..\Test\RunTest.bat
if ERRORLEVEL 1 Exit /b %ERRORLEVEL%

REM set TEST_CLIENT_ARGS=-server localhost -port 5050 -connections %NUM_CONNECTIONS% -connectionBatchSize 100 -connectionBatchDelay 100 -messages %NUM_MESSAGES% -messageSize 1000 -messageRate 0 -sendAfterRecv -skipSignOnBytes %SIGN_ON_BYTES% -readTimeout 10000 -messageFlowTimeout 60000 -fragments -multipleMessages

REM set TEST_NAME=%BASE_TEST_NAME% EchoServerTest.exe - Sync zero read, fragments, multi
REM set SERVER_ARGS=%BASE_ARGS% -syncZero

REM call ..\..\Test\RunTest.bat
REM if ERRORLEVEL 1 Exit /b %ERRORLEVEL%

REM set TEST_NAME=%BASE_TEST_NAME% EchoServerTest.exe - Async zero read, fragments, multi
REM set SERVER_ARGS=%BASE_ARGS% -asyncZero

call ..\..\Test\RunTest.bat
if ERRORLEVEL 1 Exit /b %ERRORLEVEL%

:Done
